<!DOCTYPE html>
<html lang="zxx">

<head>
  <meta charset="utf-8">
  <title>MDEF/Another page</title>

  <!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

  <!-- ** Plugins Needed for the Project ** -->
  <!-- Bootstrap -->
  <link rel="stylesheet" href="../plugins/bootstrap/bootstrap.min.css">
  <link rel="stylesheet" href="../plugins/themify/css/themify-icons.css">
  <link rel="stylesheet" href="../plugins/counto/animate.css">
  <link rel="stylesheet" href="../plugins/aos/aos.css">
  <link rel="stylesheet" href="../plugins/owl-carousel/owl.carousel.min.css">
  <link rel="stylesheet" href="../plugins/owl-carousel/owl.theme.default.min.css">
  <link rel="stylesheet" href="../plugins/magnific-popup/magnific-popup.css">
  <link rel="stylesheet" href="../plugins/animated-text/animated-text.css">

  <!-- Main Stylesheet -->
  <link href="../designspace/style.css" rel="stylesheet">

</head>


<body>

<!-- Navigation Start -->
<!-- Header Start -->

<div class= "header">

  <nav class="navbar navbar-expand-lg  main-nav " id="navbar">
  	<div class="container">
  	  <a class="navbar-brand" href="../index.html">
  	  	<img src="../images/logo.png" alt="" class="img-fluid">
  	  </a>


  	  <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#navbarsExample09" aria-controls="navbarsExample09" aria-expanded="false" aria-label="Toggle navigation">
  		<span class="ti-align-justify"></span>
  	  </button>

  		  <div class="collapse navbar-collapse" id="navbarsExample09">
  			<ul class="navbar-nav ml-auto">

  			  <li class="nav-item  active"><a class="nav-link" href="../index.html">Home</a></li>

  			  <li class="nav-item dropdown active">
  					<a class="nav-link dropdown-toggle" href="#" id="dropdown02" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">Reflection</a>
  					<ul class="dropdown-menu" aria-labelledby="dropdown02">
  						<li><a class="dropdown-item" href="../blog-grid.html">Term 1</a></li>
  						<li><a class="dropdown-item" href="../exploration/dummy.html">Term 2</a></li>
  						<li><a class="dropdown-item" href="../exploration/dummy.html">Term 3</a></li>
  					</ul>
  			  </li>

          <li class="nav-item dropdown active">
           <a class="nav-link dropdown-toggle" href="#" id="dropdown02" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">Research</a>
           <ul class="dropdown-menu" aria-labelledby="dropdown02">
             <li><a class="dropdown-item" href="../designspace/design-space.html">Design Space</a></li>
             <li><a class="dropdown-item" href="../materials.html">Materiality</a></li>
           </ul>
         </li>

  			   <li class="nav-item"><a class="nav-link" href="../contact.html">GitLab</a></li>
           <li class="nav-item  active"><a class="nav-link" href="../myself.html">About</a></li>

  			</ul>
  		</div>
  	</div>
  </nav>
</div>
<!-- Header Close -->


<section class="page-title section pb-0">
  <div class="container">
    <div class="row">
      <div class="col-lg-12">
        <div class="text-center">
          <h1 class="text-capitalize mb-0 text-lg">Input</h1>
        </div>
      </div>
    </div>
  </div>
</section>



	<div class="fabclass">
              <br> </br>
              <h2> Reading data from sensors </h2>
              <br> </br>
               <img src="input.jpg" alt="input" class="img-fluid fabimage">
               <br> </br>
                <h5>This week I understood how we can use input devices (such as sensors), to read data from the enviroment and then program an output device (such as a servo motor) to perform an action. </h5>
                <br> </br>
                <h3>1. Reading temperature data</h3>
                <div class="fabimage">
                         <p><b>Temperature sensor</b> A simple test that I did at first was to read the temperature from the sensor DS18B20. A nice documentation is found here: <a href="https://lastminuteengineers.com/ds18b20-arduino-tutorial/?fbclid=IwAR1MJZq-82xb3XQ6OXn6cWRu7YdrlFvHL5l4QfO_r6-Zx62CHHWB99hWbSU"> <i> Interfacing DS18B20 1-Wire Digital Temperature Sensor with Arduino</i></a> </p>
                          <p>The connections with Arduino Uno are pretty simple. We connect the left leg as we see the sensor from the side of the label (not the rounded one) with the ground, and the right leg with the 5V. The middle leg is the data that goes to the digital pin 2 of the Arduino. Finally, we need a 4.7K pullup resistor from data to 5V. Here is the schematic: </p>

                          <img src="tempsensor.png" alt="protocole2" class="img-fluid">
                          <br> </br>
                          <p>And the arduino code: </p>
                        <xmp>
              #include <OneWire.h>
              #include <DallasTemperature.h>

              // Data wire is plugged into digital pin 2 on the Arduino
              #define ONE_WIRE_BUS 2

              // Setup a oneWire instance to communicate with any OneWire device
              OneWire oneWire(ONE_WIRE_BUS);

              // Pass oneWire reference to DallasTemperature library
              DallasTemperature sensors(&oneWire);

              void setup(void)
              {
                sensors.begin();  // Start up the library
                Serial.begin(9600);
              }

              void loop(void)
              {
                // Send the command to get temperatures
                sensors.requestTemperatures();

                //print the temperature in Celsius
                Serial.print("Temperature: ");
                Serial.print(sensors.getTempCByIndex(0));
                Serial.print((char)176);//shows degrees character
                Serial.print("C  |  ");

                delay(500);
              }
                        </xmp>
                          <br> </br>
            <h3>2. Ultrasonic sensor and visualization at grasshopper</h3>
                          <p><b>Ultrasonic sensor</b> Another sensor that I used was the ultrasonic sensor. The sensor measures the distance from the closest obstacle in the direction that is aligned. I visualized the distance with grasshopper, changing the diameter of a circle as the measurment changes.
                          	<img src="ultra.jpg" alt="ultra-connections" class="img-fluid">
                              <br> </br>
                               <video playsinline autoplay muted loop class="img-fluid">
                              <source src="ultrasound.mp4" type="video/mp4">
                            </video>
                       </p>
                       <p>The Arduino code was: </p>

                 <pre>

                  // defines pins numbers
                  const int trigPin = 9;
                  const int echoPin = 10;
                  // defines variables
                  long duration;
                  int distance;
                  void setup() {
                  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
                  pinMode(echoPin, INPUT); // Sets the echoPin as an Input
                  Serial.begin(9600); // Starts the serial communication
                  }
                  void loop() {
                  // Clears the trigPin
                  digitalWrite(trigPin, LOW);
                  delayMicroseconds(1000);
                  // Sets the trigPin on HIGH state for 10 micro seconds
                  digitalWrite(trigPin, HIGH);
                  delayMicroseconds(1000);
                  digitalWrite(trigPin, LOW);
                  // Reads the echoPin, returns the sound wave travel time in microseconds
                  duration = pulseIn(echoPin, HIGH);
                  // Calculating the distance
                  distance= duration*0.034/2;
                  // Prints the distance on the Serial Monitor
                  Serial.print("Distance: ");
                  Serial.println(distance);
                  }

              </pre>


                <br> </br>

                <p>The firefly code: </p>
                 	<img src="fireflyultra.jpg" alt="ultra-connections" class="img-fluid">
                <br> </br>
                   <p>You can dowload the files here:<ul><li> <a href="FireflyUltrasonicSensor.ino" interlocking brick> <b>Arduino file</b> </a></li>
                   <li><a href="FireflyUltrasonicSensor.gh" interlocking brick> <b>Grasshopper file</b> </a></p> </li></ul>
        </div>


      </div>


    <section class="footer">
    	<div class="container">
    		<div class="row ">
    			<div class="col-lg-6">
    			</div>
    			<div class="col-lg-6">
    				<div class="widget footer-widget text-lg-right mt-5 mt-lg-0">
    					<ul class="list-inline mb-0">

    					</ul>
    				</div>
    			</div>
    		</div>
    	</div>
    </section>

</body>

<!-- jQuery -->
<script src="../plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="../plugins/bootstrap/bootstrap.min.js"></script>
<script src="../plugins/aos/aos.js"></script>
<script src="../plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="../plugins/shuffle/shuffle.min.js"></script>
<script src="../plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="../plugins/animated-text/animated-text.js"></script>
<script src="../plugins/counto/apear.js"></script>
<script src="../plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="../plugins/google-map/map.js"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
